glibmm 2.56.0

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gio::NetworkService Class Reference
Portable Network I/O Functionality

A GSocketConnectable for resolving SRV records. More...

`#include <giomm/networkservice.h>`

Inheritance diagram for Gio::NetworkService:
[legend]

## Public Member Functions
| NetworkService (NetworkService&& src) noexcept
NetworkService& | operator= (NetworkService&& src) noexcept
| ~NetworkService () noexcept override
GNetworkService* | gobj ()
| Provides access to the underlying C GObject. More...
const GNetworkService* | gobj () const
| Provides access to the underlying C GObject. More...
GNetworkService* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::ustring | get_service () const
| Gets srv's service name (eg, "ldap"). More...
Glib::ustring | get_protocol () const
| Gets srv's protocol name (eg, "tcp"). More...
Glib::ustring | get_domain () const
| Gets the domain that srv serves. More...
Glib::ustring | get_scheme () const
| Get's the URI scheme used to resolve proxies. More...
void | set_scheme (const Glib::ustring& scheme)
| Set's the URI scheme used to resolve proxies. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_domain () const
| Network domain, eg, 'example.com'. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_protocol () const
| Network protocol, eg 'tcp'. More...
Glib::PropertyProxy< Glib::ustring > | property_scheme ()
| Network scheme (default is to use service). More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_scheme () const
| Network scheme (default is to use service). More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_service () const
| Service name, eg 'ldap'. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Gio::SocketConnectable
| SocketConnectable (SocketConnectable&& src) noexcept
SocketConnectable& | operator= (SocketConnectable&& src) noexcept
| ~SocketConnectable () noexcept override
GSocketConnectable* | gobj ()
| Provides access to the underlying C GObject. More...
const GSocketConnectable* | gobj () const
| Provides access to the underlying C GObject. More...
Glib::RefPtr< SocketAddressEnumerator > | enumerate ()
| Creates a SocketAddressEnumerator for connectable. More...
Glib::RefPtr< const SocketAddressEnumerator > | enumerate () const
| Creates a SocketAddressEnumerator for connectable. More...
Glib::RefPtr< SocketAddressEnumerator > | proxy_enumerate ()
| Creates a SocketAddressEnumerator for connectable that will return ProxyAddresses for addresses that you must connect to via a proxy. More...
Glib::RefPtr< const SocketAddressEnumerator > | proxy_enumerate () const
| Creates a SocketAddressEnumerator for connectable that will return ProxyAddresses for addresses that you must connect to via a proxy. More...
Glib::ustring | to_string () const
| Format a SocketConnectable as a string. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (Interface&& src) noexcept
Interface& | operator= (Interface&& src) noexcept
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
| ~Interface () noexcept override
| Interface (const Interface&)=delete
Interface& | operator= (const Interface&)=delete
GObject* | gobj ()
const GObject* | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< NetworkService > | create (const Glib::ustring& service, const Glib::ustring& protocol, const Glib::ustring& domain)
Static Public Member Functions inherited from Gio::SocketConnectable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::NetworkService > | wrap (GNetworkService* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)
Related Functions inherited from Gio::SocketConnectable
Glib::RefPtr< Gio::SocketConnectable > | wrap (GSocketConnectable* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)
Protected Member Functions inherited from Gio::SocketConnectable
| SocketConnectable ()
| You should derive from this class to use it. More...

## Detailed Description

A GSocketConnectable for resolving SRV records.

Like NetworkAddress does with hostnames, NetworkService provides an easy way to resolve a SRV record, and then attempt to connect to one of the hosts that implements that service, handling service priority/weighting, multiple IP addresses, and multiple address families.

See SrvTarget for more information about SRV records, and see SocketConnectable for and example of using the connectable interface.

Since glibmm 2.24:

## Constructor & Destructor Documentation

## ◆ NetworkService()

Gio::NetworkService::NetworkService | ( | NetworkService&& | src | ) |
| noexcept

## ◆ ~NetworkService()

Gio::NetworkService::~NetworkService | ( |  | ) |
| override noexcept

## Member Function Documentation

## ◆ create()

static Glib::RefPtr<NetworkService> Gio::NetworkService::create | ( | const Glib::ustring& | service,
|  | const Glib::ustring& | protocol,
|  | const Glib::ustring& | domain
| ) |  |
| static

## ◆ get_domain()

Glib::ustring Gio::NetworkService::get_domain | ( |  | ) | const

Gets the domain that srv serves.

This might be either UTF-8 or ASCII-encoded, depending on what srv was created with.

Since glibmm 2.22:

Returns
  srv's domain name.

## ◆ get_protocol()

Glib::ustring Gio::NetworkService::get_protocol | ( |  | ) | const

Gets srv's protocol name (eg, "tcp").

Since glibmm 2.22:

Returns
  srv's protocol name.

## ◆ get_scheme()

Glib::ustring Gio::NetworkService::get_scheme | ( |  | ) | const

Get's the URI scheme used to resolve proxies.

By default, the service name is used as scheme.

Since glibmm 2.26:

Returns
  srv's scheme name.

## ◆ get_service()

Glib::ustring Gio::NetworkService::get_service | ( |  | ) | const

Gets srv's service name (eg, "ldap").

Since glibmm 2.22:

Returns
  srv's service name.

## ◆ get_type()

static GType Gio::NetworkService::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GNetworkService* Gio::NetworkService::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GNetworkService* Gio::NetworkService::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GNetworkService* Gio::NetworkService::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

NetworkService& Gio::NetworkService::operator= | ( | NetworkService&& | src | ) |
| noexcept

## ◆ property_domain()

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::NetworkService::property_domain | ( |  | ) | const

Network domain, eg, 'example.com'.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_protocol()

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::NetworkService::property_protocol | ( |  | ) | const

Network protocol, eg 'tcp'.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_scheme() [1/2]

Glib::PropertyProxy< Glib::ustring > Gio::NetworkService::property_scheme | ( |  | ) |

Network scheme (default is to use service).

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_scheme() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::NetworkService::property_scheme | ( |  | ) | const

Network scheme (default is to use service).

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_service()

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gio::NetworkService::property_service | ( |  | ) | const

Service name, eg 'ldap'.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_scheme()

void Gio::NetworkService::set_scheme | ( | const Glib::ustring& | scheme | ) |

Set's the URI scheme used to resolve proxies.

By default, the service name is used as scheme.

Since glibmm 2.26:

Parameters

  scheme | A URI scheme.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::NetworkService > wrap | ( | GNetworkService * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.